global outb         ; Make the label outb visible outside this file
; outb - send a byte to an I/O port
; Stack: 
;   [esp + 8] - the data byte
;   [esp + 4] - the I/O port
;   [esp] - return address


global inb

; inb - Returns a byte from the given I/O port
; Stack: [esp + 4] The address of the I/O port
;        [esp]     The return address

outb:
    ; Move the data byte into the AL register
    mov al, [esp + 8]       ; Data byte to AL
    ; Move the I/O port address into the DX register
    mov dx, [esp + 4]       ; I/O port address to DX
    ; Send the data byte to the I/O port
    out dx, al              ; Send AL to the port in DX
    ; Return to the calling function
    ret



inb:
    ; Move the address of the I/O port to the dx register
    mov dx, [esp + 4]

    ; Read a byte from the I/O port and store it in the al register
    in al, dx

    ; Return to the calling function
    ret

; In file io.h

/**
 * inb:
 * Read a byte from an I/O port.
 *
 * @param port The address of the I/O port
 * @return The byte read from the I/O port
 */
unsigned char inb(unsigned short port);

