global loader

; Define constants
MAGIC_NUMBER equ 0x1BADB002
FLAGS equ 0x0
CHECKSUM equ -MAGIC_NUMBER ; Calculate the checksum
; (magic number + checksum + flags should equal 0)
KERNEL_STACK_SIZE equ 4096
section .bss
align 4
kernel_stack:
resb KERNEL_STACK_SIZE
section .text
    align 4                ; The code must be 4-byte aligned
    dd MAGIC_NUMBER        ; Write the magic number to the machine
    dd FLAGS               ; The flags
    dd CHECKSUM            ; The checksum
    extern sum_of_three

loader:                   ; The loader label (defined as entry point in linker script)
    mov eax, 0xCAFEBABE   ; Place the number 0xCAFEBABE in the register eax
    mov esp, kernel_stack + KERNEL_STACK_SIZE 
    push dword 3
    push dword 2
    push dword 1
    call sum_of_three

.loop:
    jmp .loop             ; Loop forever