segment .data
    prompt_num db "Enter number of times to print the message: ", 0
    prompt db "Enter your name: ", 0
    error_prompt db "You have entered a number that does not satisfy the requirement", 0
    format db "%s", 0
    format_digit db "%d", 0
    welcome_msg db "Welcome, %s!", 0
    newline db 10, 0
segment .bss
    name resb 50 ; Reserve space for the name (50 bytes)
    num resb 1
    counter resb 1

segment .text
    extern printf
    extern scanf

global asm_main
asm_main:
    ; Print the prompt
    push prompt
    call printf
    add esp, 4          ; Clean up the stack

    ; Read the input
    push name           ; Address of the buffer to store the input
    push format         ; Format string for scanf
    call scanf
    add esp, 8          ; Clean up the stack (2 arguments)

    ;Print the number prompt
    push prompt_num
    call printf
    add esp, 4

    ; Read the number input
    push num
    push format_digit
    call scanf
    add esp, 8

     ; Loop
    mov al, [num]        ; Load the value of 'num' into register AL
    mov [counter], al    ; Store it in the counter variable


    ; Check if num > 50
    cmp al, 50           ; Compare num with 50
    jle error_exit       ; If num <= 50, jump to error_exit

    ; Check if num < 100
    cmp al, 100          ; Compare num with 100
    jge error_exit       ; If num >= 100, jump to error_exit

   

    loop_start:
    ; Do something here (inside the loop)
     ; Print the welcome message
    push name           ; Push the name to print
    push welcome_msg
    call printf
    add esp, 8        ; Clean up the stack (2 arguments)

    ; Print newline
    push newline
    call printf
    add esp, 4

    ; Decrement the counter
    dec byte [counter]    ; Decrement the value of 'counter'

    ; Check if the counter is zero
    cmp byte [counter], 0 ; Compare counter with 0
    jne loop_start        ; If not zero, jump back to loop_start


    ; Exit the program
    mov eax, 1          ; syscall: exit
    xor ebx, ebx        ; exit code 0
    ret
    int 0x80

error_exit:
    ; Exit with error code
    push error_prompt
    call printf
    add esp, 4

    ;Print newline before exiting
    push newline
    call printf
    add esp, 4

    ;Exit with error code
    mov eax, 60          ; System call for exit
    mov edi, 1           ; Exit code 1 (error)
    syscall