section .data
    sum_prompt db "The sum of the numbers is: %d", 10, 0  ; Format string for sum
    total db 0  ; Reserve space for the sum result

section .bss
    sum resd 1  ; Reserve space for the sum (4 bytes)

section .text
    extern printf

global asm_main
asm_main:

    ; Initialize registers
    xor eax, eax    ; Clear eax, we'll use it to store the sum

    ; Calculate sum of integers from 1 to 100
    mov ecx, 1      ; Start loop counter at 1
    mov ebx, 100    ; Upper limit of the loop

calculate_sum:
    add eax, ecx    ; Add the current counter value to the sum (in eax)
    inc ecx         ; Increment the counter
    cmp ecx, ebx    ; Compare counter with 100
    jle calculate_sum ; Loop if counter is <= 100

    ; Now eax contains the sum of numbers from 1 to 100

    ; Store the sum in the variable sum
    mov [sum], eax

    ; Print the sum using printf
    push eax          ; Push the sum onto the stack (argument for printf)
    push sum_prompt   ; Push the format string
    call printf      ; Call printf
    add esp, 8        ; Clean up the stack (2 arguments)

    ; Exit the program
    mov eax, 1          ; syscall: exit
    xor ebx, ebx        ; exit code 0
    ret
    int 0x80
