section .data
    sum_prompt db "The sum of the numbers is: %d", 10, 0  ; Format string for sum
    prompt_start db "Enter the start of the range: ", 0
    prompt_end_range db "Enter the end of the range: ", 0
    format db "%d", 0
    newline db 10, 0
    total db 0  ; Reserve space for the sum result

section .bss
    sum resd 1  ; Reserve space for the sum (4 bytes)
    start_range resd 1
    end_range resd 1

section .text
    extern printf
    extern scanf

global asm_main
asm_main:
    ; Print start prompt
    push prompt_start
    call printf
    add esp, 4

    ; Scan start range
    push start_range
    push format
    call scanf
    add esp, 8

    ; Print end range prompt
    push prompt_end_range
    call printf
    add esp, 4

    ; Scan end range
    push end_range
    push format
    call scanf
    add esp, 8

    ; Initialize sum register (eax = 0)
    xor eax, eax    ; Clear eax register to store the sum

    ; Load start and end range values into registers
    mov ecx, [start_range]   ; Start range (ecx)
    mov ebx, [end_range]     ; End range (ebx)

calculate_sum:
    cmp ecx, ebx        ; Compare start value (ecx) with end value (ebx)
    jg done_calculation  ; If start > end, exit the loop

    add eax, ecx        ; Add current value of ecx to eax (sum)
    inc ecx             ; Increment ecx to move to the next number
    jmp calculate_sum   ; Repeat the loop

done_calculation:
    ; Now eax contains the sum of numbers from start_range to end_range

    ; Store the sum in the sum variable (optional)
    mov [sum], eax

    ; Print the sum using printf
    push eax            ; Push the sum onto the stack (argument for printf)
    push sum_prompt     ; Push the format string
    call printf         ; Call printf
    add esp, 8          ; Clean up the stack (2 arguments)

    ; Exit the program
    mov eax, 1          ; syscall: exit
    xor ebx, ebx        ; exit code 0
    ret
    int 0x80
